## llvm-toolchain-snapshot 19~++20240125092523+41fe98a6e7e5

=== lldb/source/Breakpoint/CMakeLists.txt ===
add_lldb_library(lldbBreakpoint NO_PLUGIN_DEPENDENCIES
  Breakpoint.cpp
  BreakpointID.cpp
  BreakpointIDList.cpp
  BreakpointList.cpp
  BreakpointLocation.cpp
  BreakpointLocationCollection.cpp
  BreakpointLocationList.cpp
  BreakpointName.cpp
  BreakpointOptions.cpp
  BreakpointPrecondition.cpp
  BreakpointResolver.cpp
  BreakpointResolverAddress.cpp
  BreakpointResolverFileLine.cpp
  BreakpointResolverFileRegex.cpp
  BreakpointResolverName.cpp
  BreakpointResolverScripted.cpp
  BreakpointSite.cpp
  Stoppoint.cpp
  StoppointCallbackContext.cpp
  StoppointSite.cpp
  StopPointSiteList.cpp
  Watchpoint.cpp
  WatchpointList.cpp
  WatchpointOptions.cpp
  WatchpointResource.cpp

  LINK_LIBS
    lldbCore
    lldbExpression
    lldbInterpreter
    lldbSymbol
    lldbTarget
    lldbUtility

  LINK_COMPONENTS
    Support
  )

=== clang/include/clang/Basic/CMakeLists.txt ===
macro(clang_diag_gen component)
  clang_tablegen(Diagnostic${component}Kinds.inc
    -gen-clang-diags-defs -clang-component=${component}
    SOURCE Diagnostic.td
    TARGET ClangDiagnostic${component})
endmacro(clang_diag_gen)

clang_diag_gen(Analysis)
clang_diag_gen(AST)
clang_diag_gen(Comment)
clang_diag_gen(Common)
clang_diag_gen(CrossTU)
clang_diag_gen(Driver)
clang_diag_gen(Frontend)
clang_diag_gen(Lex)
clang_diag_gen(Parse)
clang_diag_gen(Refactoring)
clang_diag_gen(Sema)
clang_diag_gen(Serialization)
clang_tablegen(DiagnosticGroups.inc -gen-clang-diag-groups
  SOURCE Diagnostic.td
  TARGET ClangDiagnosticGroups)

clang_tablegen(DiagnosticIndexName.inc -gen-clang-diags-index-name
  SOURCE Diagnostic.td
  TARGET ClangDiagnosticIndexName)

clang_tablegen(AttrList.inc -gen-clang-attr-list
  -I ${CMAKE_CURRENT_SOURCE_DIR}/../../
  SOURCE Attr.td
  TARGET ClangAttrList)

clang_tablegen(AttrLeftSideCanPrintList.inc -gen-clang-attr-can-print-left-list
  -I ${CMAKE_CURRENT_SOURCE_DIR}/../../
  SOURCE Attr.td
  TARGET ClangAttrCanPrintLeftList)

clang_tablegen(AttrLeftSideMustPrintList.inc -gen-clang-attr-must-print-left-list
  -I ${CMAKE_CURRENT_SOURCE_DIR}/../../
  SOURCE Attr.td
  TARGET ClangAttrMustPrintLeftList)

clang_tablegen(AttrSubMatchRulesList.inc -gen-clang-attr-subject-match-rule-list
  -I ${CMAKE_CURRENT_SOURCE_DIR}/../../
  SOURCE Attr.td
  TARGET ClangAttrSubjectMatchRuleList)

clang_tablegen(RegularKeywordAttrInfo.inc -gen-clang-regular-keyword-attr-info
  -I ${CMAKE_CURRENT_SOURCE_DIR}/../../
  SOURCE Attr.td
  TARGET ClangRegularKeywordAttrInfo
  )

clang_tablegen(AttrHasAttributeImpl.inc -gen-clang-attr-has-attribute-impl
  -I ${CMAKE_CURRENT_SOURCE_DIR}/../../
  SOURCE Attr.td
  TARGET ClangAttrHasAttributeImpl
  )

clang_tablegen(Builtins.inc -gen-clang-builtins
  SOURCE Builtins.td
  TARGET ClangBuiltins)

clang_tablegen(BuiltinsBPF.inc -gen-clang-builtins
  SOURCE BuiltinsBPF.td
  TARGET ClangBuiltinsBPF)

# ARM NEON and MVE
clang_tablegen(arm_neon.inc -gen-arm-neon-sema
  SOURCE arm_neon.td
  TARGET ClangARMNeon)
clang_tablegen(arm_fp16.inc -gen-arm-neon-sema
  SOURCE arm_fp16.td
  TARGET ClangARMFP16)
clang_tablegen(arm_mve_builtins.inc -gen-arm-mve-builtin-def
  SOURCE arm_mve.td
  TARGET ClangARMMveBuiltinsDef)
clang_tablegen(arm_mve_builtin_cg.inc -gen-arm-mve-builtin-codegen
  SOURCE arm_mve.td
  TARGET ClangARMMveBuiltinCG)
clang_tablegen(arm_mve_builtin_sema.inc -gen-arm-mve-builtin-sema
  SOURCE arm_mve.td
  TARGET ClangARMMveBuiltinSema)
clang_tablegen(arm_mve_builtin_aliases.inc -gen-arm-mve-builtin-aliases
  SOURCE arm_mve.td
  TARGET ClangARMMveBuiltinAliases)
clang_tablegen(arm_sve_builtins.inc -gen-arm-sve-builtins
  SOURCE arm_sve.td
  TARGET ClangARMSveBuiltins)
clang_tablegen(arm_sve_builtin_cg.inc -gen-arm-sve-builtin-codegen
  SOURCE arm_sve.td
  TARGET ClangARMSveBuiltinCG)
clang_tablegen(arm_sve_typeflags.inc -gen-arm-sve-typeflags
  SOURCE arm_sve.td
  TARGET ClangARMSveTypeFlags)
clang_tablegen(arm_sve_sema_rangechecks.inc -gen-arm-sve-sema-rangechecks
  SOURCE arm_sve.td
  TARGET ClangARMSveSemaRangeChecks)
clang_tablegen(arm_sve_streaming_attrs.inc -gen-arm-sve-streaming-attrs
  SOURCE arm_sve.td
  TARGET ClangARMSveStreamingAttrs)
clang_tablegen(arm_sme_builtins.inc -gen-arm-sme-builtins
  SOURCE arm_sme.td
  TARGET ClangARMSmeBuiltins)
clang_tablegen(arm_sme_builtin_cg.inc -gen-arm-sme-builtin-codegen
  SOURCE arm_sme.td
  TARGET ClangARMSmeBuiltinCG)
clang_tablegen(arm_sme_sema_rangechecks.inc -gen-arm-sme-sema-rangechecks
  SOURCE arm_sme.td
  TARGET ClangARMSmeSemaRangeChecks)
clang_tablegen(arm_sme_streaming_attrs.inc -gen-arm-sme-streaming-attrs
  SOURCE arm_sme.td
  TARGET ClangARMSmeStreamingAttrs)
clang_tablegen(arm_sme_builtins_za_state.inc -gen-arm-sme-builtin-za-state
  SOURCE arm_sme.td
  TARGET ClangARMSmeBuiltinsZAState)
clang_tablegen(arm_cde_builtins.inc -gen-arm-cde-builtin-def
  SOURCE arm_cde.td
  TARGET ClangARMCdeBuiltinsDef)
clang_tablegen(arm_cde_builtin_cg.inc -gen-arm-cde-builtin-codegen
  SOURCE arm_cde.td
  TARGET ClangARMCdeBuiltinCG)
clang_tablegen(arm_cde_builtin_sema.inc -gen-arm-cde-builtin-sema
  SOURCE arm_cde.td
  TARGET ClangARMCdeBuiltinSema)
clang_tablegen(arm_cde_builtin_aliases.inc -gen-arm-cde-builtin-aliases
  SOURCE arm_cde.td
  TARGET ClangARMCdeBuiltinAliases)
clang_tablegen(riscv_vector_builtins.inc -gen-riscv-vector-builtins
  SOURCE riscv_vector.td
  TARGET ClangRISCVVectorBuiltins)
clang_tablegen(riscv_vector_builtin_cg.inc -gen-riscv-vector-builtin-codegen
  SOURCE riscv_vector.td
  TARGET ClangRISCVVectorBuiltinCG)
clang_tablegen(riscv_vector_builtin_sema.inc -gen-riscv-vector-builtin-sema
  SOURCE riscv_vector.td
  TARGET ClangRISCVVectorBuiltinSema)
clang_tablegen(riscv_sifive_vector_builtins.inc -gen-riscv-sifive-vector-builtins
  SOURCE riscv_sifive_vector.td
  TARGET ClangRISCVSiFiveVectorBuiltins)
clang_tablegen(riscv_sifive_vector_builtin_cg.inc -gen-riscv-sifive-vector-builtin-codegen
  SOURCE riscv_sifive_vector.td
  TARGET ClangRISCVSiFiveVectorBuiltinCG)
clang_tablegen(riscv_sifive_vector_builtin_sema.inc -gen-riscv-sifive-vector-builtin-sema
  SOURCE riscv_sifive_vector.td
  TARGET ClangRISCVSiFiveVectorBuiltinSema)

=== debian/changelog ===
llvm-toolchain-snapshot (1:19~++20240125092523+41fe98a6e7e5-1~exp1) experimental; urgency=medium

  * branch of 19
  * refresh libomp5 symbol list
  * For the usage of -DLIBCXXABI_USE_LLVM_UNWINDER=OFF when we don't build unwind
    https://github.com/llvm/llvm-project/issues/77846
  * remove the unconditionnaly defined -DLIBUNWIND_USE_COMPILER_RT=ON
  * Also pass -DLIBCXXABI_USE_LLVM_UNWINDER:BOOL=OFF to libcxx-wasm32-wasi builds

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 25 Jan 2024 14:51:10 +0100

llvm-toolchain-18 (1:18~++20240124100819+22683463740e-1~exp1) experimental; urgency=medium

  * Branching of 18
  * refresh libomp5 symbol list
  * For the usage of -DLIBCXXABI_USE_LLVM_UNWINDER=OFF when we don't build unwind
    https://github.com/llvm/llvm-project/issues/77846
  * remove the unconditionnaly defined -DLIBUNWIND_USE_COMPILER_RT=ON
  * Also pass -DLIBCXXABI_USE_LLVM_UNWINDER:BOOL=OFF to libcxx-wasm32-wasi builds

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 24 Jan 2024 22:14:15 +0100

llvm-toolchain-17 (1:17.0.6-6) UNRELEASED; urgency=medium

  [ chenli ]
  * Enable flang on loong64

  [ Sylvestre Ledru ]
  * try to enable sccache on 'my' s390x machines

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 24 Jan 2024 13:29:35 +0100

llvm-toolchain-17 (1:17.0.6-5) unstable; urgency=medium

  [ Faidon Liambotis ]
  * Revert "Enable COMPILER_RT_BUILD_BUILTINS for armel"
  * Fix i386 FTBFS resulting from COMPILER_RT_DEFAULT_TARGET_ONLY
    (Closes: #1060440)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 11 Jan 2024 14:15:09 +0100

llvm-toolchain-17 (1:17.0.6-4) unstable; urgency=medium

  * debian/qualify-clang.sh: remove the compiler-rt test of i386
    use libclang-rt-17-dev:i386 instead

  [ Matthias Klose ]
  * libclang1-17: Remove the full version symlinks.

  [ Faidon Liambotis ]
  * Enable COMPILER_RT_DEFAULT_TARGET_ONLY for all archs
  * Enable COMPILER_RT_BUILD_BUILTINS for armel
  * Drop two unreferenced debian/patches
  * Mark documentation packages as Multi-Arch: foreign
  * Convert libclang-common-*-dev to Arch: all/M-A: foreign

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 09 Jan 2024 13:03:56 +0100

llvm-toolchain-17 (1:17.0.6-3) unstable; urgency=medium

  * Cherry pick the wasm fix from 16
    (Closes: #1057838)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 15 Dec 2023 18:51:57 +0100

=== debian/control ===
Source: llvm-toolchain-snapshot
Section: devel
Priority: optional
Rules-Requires-Root: no
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>, Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: debhelper (>= 10.0), cmake, ninja-build,
    chrpath, texinfo, sharutils,
    libelf-dev,
    libffi-dev,
    lsb-release, patchutils, diffstat, xz-utils, python3-dev,
    libedit-dev, libncurses-dev, swig, python3-sphinx (>= 1.3.6),
    binutils-dev,
    libxml2-dev,
    libjsoncpp-dev, pkg-config,
    lcov, procps, help2man,
    zlib1g-dev, libzstd-dev,
    g++-multilib [amd64 i386 kfreebsd-amd64 mips64 mips64el mipsel powerpc ppc64 s390 s390x sparc sparc64 x32],
    libjs-mathjax, python3-myst-parser | python3-recommonmark,
    doxygen,
    ocaml-base [amd64 arm64 armhf ppc64el riscv64 s390x] | ocaml-nox [amd64 arm64 armhf ppc64el riscv64 s390x],
    ocaml-findlib [amd64 arm64 armhf ppc64el riscv64 s390x],
    libctypes-ocaml-dev [amd64 arm64 armhf ppc64el riscv64 s390x],
    dh-exec, dh-ocaml [amd64 arm64 armhf ppc64el riscv64 s390x],
    libpfm4-dev [linux-any], python3-setuptools, libz3-dev,
    llvm-spirv-17 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello,
    spirv-tools [linux-any] | hello [!i386],
    wasi-libc | hello,
    libcurl4-openssl-dev | libcurl-dev,
    libgrpc++-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
    protobuf-compiler-grpc [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
    libprotobuf-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
    protobuf-compiler [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x]
# "| hello" is for older buster/bionic distros without spirv support
Build-Conflicts: oprofile
Standards-Version: 4.6.2
Homepage: https://www.llvm.org/
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain.git -b snapshot
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain/tree/snapshot

# ------------- clang -------------

Package: clang-19
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc},
 libllvm19 (= ${binary:Version}),
 libclang-common-19-dev (= ${source:Version}),
 llvm-19-linker-tools (= ${binary:Version}),
 libclang1-19 (= ${binary:Version}), libc6-dev, binutils
Provides: c-compiler, objc-compiler, c++-compiler
Recommends: llvm-19-dev, python3
# libomp-19-dev
Suggests: clang-19-doc, wasi-libc
Description: C, C++ and Objective-C compiler
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.

Package: clang-tools-19
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-19 (= ${binary:Version}),
 python3
Description: clang-based tools for C/C++ developments
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains some clang-based tools like scan-build, clang-cl, etc.

Package: clang-format-19
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm19 (= ${binary:Version})
Description: Tool to format C/C++/Obj-C code
 Clang-format is both a library and a stand-alone tool with the goal of
 automatically reformatting C++ sources files according to configurable
 style guides. To do so, clang-format uses Clang's Lexer to transform an
 input file into a token stream and then changes all the whitespace around
 those tokens. The goal is for clang-format to both serve both as a user
 tool (ideally with powerful IDE integrations) and part of other
 refactoring tools, e.g. to do a reformatting of all the lines changed
 during a renaming.
 .
 This package also provides vim and emacs plugins.

Package: clang-tidy-19
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm19 (= ${binary:Version}),
 libclang-common-19-dev (= ${source:Version}),
 clang-tools-19, python3-yaml
Description: clang-based C++ linter tool
 Provide an extensible framework for diagnosing and fixing typical programming
 errors, like style violations, interface misuse, or bugs that can be deduced
 via static analysis. clang-tidy is modular and provides a convenient interface
 for writing new checks.

Package: clangd-19
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libllvm19 (= ${binary:Version}),
 libclang-common-19-dev (= ${source:Version}),
Description: Language server that provides IDE-like features to editors
 clangd understands your C++ code and adds smart features to your editor:
  - code completion
  - compile errors
  - go-to-definition
  - and more.
 .
 clangd is a language server that implements the Language Server Protocol;
 it can work with many editors through a plugin.

Package: clang-19-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-mathjax
Description: C, C++ and Objective-C compiler - Documentation
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the documentation.

Package: libclang1-19
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang library.
 .
 The C Interface to Clang provides a relatively small API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-19-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc}, libclang1-19 (= ${binary:Version}),
 libclang-common-19-dev (= ${source:Version})
Description: Clang library - Development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang headers to develop extensions over
 libclang1-19.

Package: libclang-common-19-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends},
Recommends: libclang-rt-19-dev
Description: Clang library - Common development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang generic headers.

# ------------- compiler-rt -------------

Package: libclang-rt-19-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - development package
 This package provides various libraries:
 .
   * builtins - Simple libraries that provide implementation of the
     low-level target-specific hooks required by code generation
     and other runtime components.
   * sanitizer runtimes - AddressSanitizer, ThreadSanitizer,
     UndefinedBehaviorSanitizer, MemorySanitizer, LeakSanitizer
     DataFlowSanitizer, etc
   * profile - Library which is used to collect coverage information.

Package: libclang-rt-19-dev-wasm32
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - wasm32 builtins
 Provides the compiler-rt builtins for WebAssembly 32 bits

Package: libclang-rt-19-dev-wasm64
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - wasm64 builtins
 Provides the compiler-rt builtins for WebAssembly 64 bits

# ------------- polly -------------

Package: libpolly-19-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: High-level loop and data-locality optimizer
 Uses an abstract mathematical representation based on integer polyhedra
 to analyze and optimize the memory access pattern of a program

# ------------- clang libraries -------------

Package: libclang-cpp19
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libllvm19 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: C++ interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang C++ library.
 .
 The C++ Interface to Clang provides an API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-cpp19-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 libclang-cpp19 (= ${binary:Version})
# Move of libclang-cpp.so into libclang-cpp19.dev
Description: C++ interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang C++ library.
 .
 The C++ Interface to Clang provides an API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.
 .
 This package contains symlinks without a version number, which needed by
 linker at build time.


Package: libfuzzer-19-dev
Architecture: linux-any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-19 (= ${binary:Version})
Description: Library for coverage-guided fuzz testing
 LibFuzzer is a library for in-process, coverage-guided, evolutionary fuzzing
 of other libraries.
 .
 LibFuzzer is similar in concept to American Fuzzy Lop (AFL), but it performs
 all of its fuzzing inside a single process. This in-process fuzzing can be
 more restrictive and fragile, but is potentially much faster as there is no
 overhead for process start-up.
 .
 The fuzzer is linked with the library under test, and feeds fuzzed inputs to
 the library via a specific fuzzing entrypoint (aka 'target function'); the

=== debian/rules ===
#!/usr/bin/make -f

# polly & lldb aren't enabled for every platform
PROJECTS = clang;clang-tools-extra;lld;cross-project-tests;mlir
# openmp & libunwind aren't enabled for every platform
RUNTIMES = compiler-rt;libcxx;libcxxabi

TARGET_BUILD	:= build-llvm
TARGET_BUILD_STAGE2    := $(TARGET_BUILD)/tools/clang/stage2-bins
DEB_INST		:= $(CURDIR)/debian/tmp/

GXX_VERSIONED_PACKAGE    := $(shell dpkg-query -W -f '$${Depends}' g++ | grep -o 'g++-[0-9][0-9.]*' | tail -n1 )
GXX_VERSIONED_EXECUTABLE := $(shell dpkg -L $(GXX_VERSIONED_PACKAGE) | grep '/usr/bin/g++-[0-9][0-9.]*' | xargs ls -d | tail -n1 )
GCC_VERSION              := $(subst /usr/bin/g++-,,$(GXX_VERSIONED_EXECUTABLE))

LLVM_EPOCH := 1:
LLVM_VERSION   := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:([0-9]+).*,\1,p")
LLVM_VERSION_FULL := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\1,p")
LLVM_VERSION_SNAPSHOT := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:(.*),\1,p")
ifeq ($(LLVM_VERSION),$(LLVM_VERSION_FULL))
	LLVM_VERSION_FULL := $(LLVM_VERSION).0.0
endif
LLVM_VERSION_NEXT := $(shell echo $(LLVM_VERSION_FULL) | awk -F. '{ OFS="."; $$NF+=1; print}')

SOURCE_NAME := $(shell dpkg-parsechangelog -S Source)
ifneq (,$(findstring snapshot,$(SOURCE_NAME)))
  BRANCH_NAME=snapshot
else
  BRANCH_NAME=$(LLVM_VERSION)
endif

VENDOR=$(shell lsb_release -is)
DISTRO=$(shell lsb_release -sc)

SONAME_EXT      := 1
SONAME_OPENMP	:= 5
# Manage the case when the version is 3.5~svn213052-1~exp1 or 3.4.2-1
DEBIAN_REVISION := $(shell dpkg-parsechangelog |  sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\3,p")
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NCPUS := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
else
  NCPUS := $(shell nproc)
endif

# this contains all packages to be built. Note that for at least the clean target,
# this always includes the binary-indep packages.
packages := $(shell dh_listpackages)

# flang has some memory hogs, of up to 6.2gb per process. Limit the parallel jobs
# based on the available memory
ifneq (,$(filter flang-$(LLVM_VERSION), $(packages)))
  MEM_PER_CPU=4500
else
  MEM_PER_CPU=2100
endif
NJOBS := $(shell mt=`awk '/^(MemAvail|SwapFree)/ { mt += $$2 } END {print mt}' /proc/meminfo`; \
		awk -vn=$(NCPUS) -vmt=$$mt -vm=$(MEM_PER_CPU) \
		  'END { mt/=1024; n2 = int(mt/m); print n==1 ? 1 : n2<n+1 ? n2 : n+1}' < /dev/null)

DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')

include /usr/share/dpkg/architecture.mk

CONFIGURE_EXTRA =

# dpkg-buildflags support
# disable fixfilepath in favor of the llvm-project supplied flavor, disable lto
export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
# these are handled on a per stage / build basis
ifeq ($(VENDOR)-$(DEB_HOST_ARCH),Ubuntu-ppc64el)
  export DEB_CFLAGS_MAINT_STRIP = -g -O3
  export DEB_CXXFLAGS_MAINT_STRIP = -g -O3
else
  export DEB_CFLAGS_MAINT_STRIP = -g -O2
  export DEB_CXXFLAGS_MAINT_STRIP = -g -O2
endif
include /usr/share/dpkg/buildflags.mk

# We use a stage2 build. It means that a first clang is built using gcc,
# a second clang is built with the first
# And the various components are built using the second clang.
# See https://llvm.org/docs/AdvancedBuilds.html

# collect additional flags for all stages all builds
CFLAGS_EXTRA = -Wno-unused-command-line-argument
CXXFLAGS_EXTRA = -Wno-unused-command-line-argument
LDFLAGS_EXTRA = -Wl,--build-id

# collect all flags for stage 1 toolchain build only
STAGE_1_CFLAGS = $(CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS)
STAGE_1_CXXFLAGS = $(CXXFLAGS) $(CXXFLAGS_EXTRA) $(CPPFLAGS)
STAGE_1_LDFLAGS = $(LDFLAGS) $(LDFLAGS_EXTRA)
# If we build with libc++, we might want to set different arguments for
# stage 1 & runtimes
RUNTIMES_CFLAGS = $(STAGE_1_CFLAGS)
RUNTIMES_CXXFLAGS := $(STAGE_1_CXXFLAGS)
RUNTIMES_LDFLAGS := $(STAGE_1_LDFLAGS)

# collect all flags for stage 2 toolchain and stand-alone builds
STAGE_2_CFLAGS = $(CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS)
STAGE_2_CXXFLAGS = $(CXXFLAGS) $(CXXFLAGS_EXTRA) $(CPPFLAGS)
STAGE_2_LDFLAGS = $(LDFLAGS) $(LDFLAGS_EXTRA)

# collect additional cmake options for toolchain build configuration
STAGE_1_CMAKE_EXTRA =
STAGE_2_CMAKE_EXTRA =
STAGE_ALL_CMAKE_EXTRA =
# toolchain config-only var combining all stage 1 cmake options
CMAKE_EXTRA = $(STAGE_1_CMAKE_EXTRA) $(STAGE_ALL_CMAKE_EXTRA)
# toolchain config-only var prepending BOOTSTRAP_ to all stage 2 cmake options
BOOTSTRAP_CMAKE_EXTRA = $(foreach extra,$(STAGE_2_CMAKE_EXTRA) $(STAGE_ALL_CMAKE_EXTRA), $(subst -D,-DBOOTSTRAP_,$(extra)))

BASE_PATH := $(CURDIR)
STAGE_1_BIN_DIR := $(BASE_PATH)/$(TARGET_BUILD)/bin
STAGE_1_LIB_DIR := $(BASE_PATH)/$(TARGET_BUILD)/lib
STAGE_2_BIN_DIR := $(BASE_PATH)/$(TARGET_BUILD_STAGE2)/bin
STAGE_2_LIB_DIR := $(BASE_PATH)/$(TARGET_BUILD_STAGE2)/lib

# toggleable defaults
COMPILER_RT_USE_BUILTINS_LIBRARY := ON
LIBCXX_EXCEPTIONS := ON
LIBCXX_USE_COMPILER_RT := ON

# We want to set the clang extra version ONLY in stage 2
# because we want the clang stage 1 to be as reproducible as possible
# when building with sccache (because this tool do a hash using the
# compiler binary and other things)
STAGE_2_CMAKE_EXTRA += -DCLANG_REPOSITORY_STRING=$(DEBIAN_REVISION)

ifneq (,$(filter $(DEB_HOST_ARCH),sparc sparc64))
STAGE_1_CMAKE_EXTRA += -DLLVM_PARALLEL_LINK_JOBS=4
endif

ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 kfreebsd-i386 armel mipsel powerpc powerpcspe riscv64))
# For some reason, in the stage2 build, when clang is used to compile
# itself. The atomic detection is failing on armel and riscv64. Forcing the inclusion
# everywhere and in all stages
LDFLAGS_EXTRA += -latomic
endif

Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=OFF
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libz3-dev) gt 4.7.0; echo $$?),0)
# no ocaml support in main for Ubuntu
ifneq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=ON
endif
endif
STAGE_2_CMAKE_EXTRA += $(Z3_FLAG)

# Change the default CPU for s390x
ZARCH=z196
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
ZARCH=z13
endif
STAGE_2_CMAKE_EXTRA += -DCLANG_SYSTEMZ_DEFAULT_ARCH=$(ZARCH)

# clangd remote index support requires GRPC & protobuf.
# Enable if minimum tested versions are available.
CLANGD_GRPC_INSTALLED=no
ifeq ($(shell v=$$(dpkg-query -W -f '$${Version}' libgrpc++-dev 2>/dev/null); if [ -z "$$v" ]; then echo 1; else dpkg --compare-versions $$v gt 1.30.0; echo $$?; fi),0)
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' protobuf-compiler-grpc) gt 1.30.0; echo $$?),0)
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libprotobuf-dev) gt 3.12.0; echo $$?),0)
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' protobuf-compiler) gt 3.12.0; echo $$?),0)
CLANGD_GRPC_INSTALLED=yes
STAGE_2_CMAKE_EXTRA += -DCLANGD_ENABLE_REMOTE=ON
endif
endif
endif
endif

export CC=gcc-$(GCC_VERSION)
export CXX=g++-$(GCC_VERSION)

ifneq (,$(findstring $(DEB_HOST_ARCH),armel))
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=arm-linux-gnueabi
# align arch profile with debian baseline
# https://wiki.debian.org/ArmEabiPort
  CFLAGS_EXTRA += -march=armv5t
  CXXFLAGS_EXTRA += -march=armv5t
# disable compiler-rt builtins (not supported for baseline armel arch: armv5t)
# See http://lists.llvm.org/pipermail/llvm-dev/2016-May/099761.html
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_BUILD_BUILTINS=OFF
  COMPILER_RT_USE_BUILTINS_LIBRARY := OFF
  LIBCXX_USE_COMPILER_RT := OFF
# disable scudo standalone (not supported for baseline armel arch: armv5t)
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_BUILD_SCUDO_STANDALONE=OFF
endif

ifneq (,$(findstring $(DEB_HOST_ARCH),armhf))
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=arm-linux-gnueabihf
# align arch profile with debian baseline
# https://wiki.debian.org/ArmHardFloatPort#Minimum_CPU_.26_FPU

## llvm-toolchain-snapshot 19~++20240304085905+c7fdd8c11e54

=== debian/changelog ===
llvm-toolchain-snapshot (1:19~++20240304085905+c7fdd8c11e54-1ubuntu6) noble; urgency=medium

  * No-change rebuild for restored abseil t64.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Apr 2024 15:23:19 +0200

llvm-toolchain-snapshot (1:19~++20240304085905+c7fdd8c11e54-1ubuntu5) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:30:37 +0000

llvm-toolchain-snapshot (1:19~++20240304085905+c7fdd8c11e54-1ubuntu4) noble; urgency=medium

  * No-change rebuild against abseil t64.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 22 Mar 2024 03:00:23 +0100

llvm-toolchain-snapshot (1:19~++20240304085905+c7fdd8c11e54-1ubuntu3) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:43:05 +0000

llvm-toolchain-snapshot (1:19~++20240304085905+c7fdd8c11e54-1ubuntu2) noble; urgency=medium

  * Drop "| hello" build dependencies.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 12 Mar 2024 13:52:52 +0100

llvm-toolchain-snapshot (1:19~++20240304085905+c7fdd8c11e54-1ubuntu1) noble; urgency=medium

  * Make libclang-common-19-dev architecture dependent.
  * Add python3-pexpect in the build dep for lldb.
  * Fix sanitizer build on 32bit time_t64 architectures.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 12 Mar 2024 12:54:07 +0100

llvm-toolchain-snapshot (1:19~++20240304085905+c7fdd8c11e54-1~exp1) experimental; urgency=medium

  [ Sylvestre Ledru ]
  * New snapshot release
  * hwasan_symbolize is now built also on i386
  * Update of the libomp symbols
  * Also install usr/lib/llvm-19/lib/libLLVM.so.1
    and usr/lib/llvm-19/lib/libLLVM.so.19.0
  * Install clang-installapi as part of clang-tools
  * Disable the install of libomp in sub arch
    Following 1977404d20ab29ff78a58d8c0f1f4c5e7aef6b16

  [ John Paul Adrian Glaubitz ]
  * Install *clang_rt* on sparc and sparc64
  * Run chrpath for libclang on sparc and sparc64

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 04 Mar 2024 09:00:56 +0100

llvm-toolchain-18 (1:18.1.0~rc4-1) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Install *clang_rt* on sparc and sparc64
  * Run chrpath for libclang on sparc and sparc64

  [ Sylvestre Ledru ]
  * New snapshot release
  * add -DLIBCXX_INSTALL_MODULES=ON to install libc++ C++-20 modules
    see https://discourse.llvm.org/t/libc-c-23-module-installation-support/77061/1
  * Add a new package libllvmlibc-18-dev to ship LLVM libc (experimental for now)
    (amd64, arm64 and armhf)
  [ John Paul Adrian Glaubitz ]
  * Install *clang_rt* on sparc and sparc64
  * Run chrpath for libclang on sparc and sparc64

  [ Sylvestre Ledru ]
  * New snapshot release
  * add -DLIBCXX_INSTALL_MODULES=ON to install libc++ C++-20 modules
    see https://discourse.llvm.org/t/libc-c-23-module-installation-support/77061/1
  * Add a new package libllvmlibc-18-dev to ship LLVM libc (experimental for now)
    (amd64, arm64 and armhf)
  * Also install usr/lib/llvm-19/lib/libLLVM.so.1
    and usr/lib/llvm-19/lib/libLLVM.so.18.0

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 28 Feb 2024 11:08:41 +0100

llvm-toolchain-18 (1:18.1.0~rc2-4) unstable; urgency=medium

  * Fix 32bit builds, exclude i386, don't build clang-rt there
  * Revert gold linker on mips64el
  * Disable stack protector on mips64el
  [ John Paul Adrian Glaubitz ]
  * Install *clang_rt* on sparc and sparc64
  * Run chrpath for libclang on sparc and sparc64

  [ Sylvestre Ledru ]
  * add -DLIBCXX_INSTALL_MODULES=ON
    see https://discourse.llvm.org/t/libc-c-23-module-installation-support/77061/1
    Ship libc++-18-dev /usr/lib/llvm-18/lib/libc++.modules.json /usr/lib/llvm-18/include/c++/v1/std.compat.cppm
    /usr/lib/llvm-18/include/c++/v1/std.cppm
  [ John Paul Adrian Glaubitz ]
  * Install *clang_rt* on sparc and sparc64
  * Run chrpath for libclang on sparc and sparc64

  [ Sylvestre Ledru ]
  * add -DLIBCXX_INSTALL_MODULES=ON to install libc++ C++-20 modules
    see https://discourse.llvm.org/t/libc-c-23-module-installation-support/77061/1
  [ John Paul Adrian Glaubitz ]
  * Install *clang_rt* on sparc and sparc64
  * Run chrpath for libclang on sparc and sparc64

  [ Sylvestre Ledru ]
  * add -DLIBCXX_INSTALL_MODULES=ON to install libc++ C++-20 modules
    see https://discourse.llvm.org/t/libc-c-23-module-installation-support/77061/1
  * Add a new package libllvmlibc-18-dev to ship LLVM libc (experimental for now)
  * Fix 32bit builds, exclude i386, don't build clang-rt there
  * Revert gold linker on mips64el
  * Disable stack protector on mips64el
  * Fix 32bit builds, exclude i386, don't build clang-rt there
  * Revert gold linker on mips64el
  * Disable stack protector on mips64el

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 22 Feb 2024 17:58:05 +0100

llvm-toolchain-18 (1:18.1.0~rc2-3) unstable; urgency=medium

  * Add abi=+time64,+lfs only on 64bits system

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 11 Feb 2024 14:29:31 +0100

llvm-toolchain-18 (1:18.1.0~rc2-2) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Try gold linker on mips64el
  * Add also lfs on top of time64, to fix FTBFS on 32bit

  [ Sylvestre Ledru ]
  * add new symbols in libomp5

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 08 Feb 2024 16:38:35 +0100

llvm-toolchain-18 (1:18.1.0~rc2-1) unstable; urgency=medium

  * New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 07 Feb 2024 21:15:53 +0100

llvm-toolchain-18 (1:18.1.0~rc1-3) unstable; urgency=medium

  * Fix previus upload, time64 is effective only in one specific place of
    rules file
  * Fix some test using still clang-17
  * Switch testing to 18 line
  * Fix an underlinking on qualify-clang.sh

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 07 Feb 2024 15:05:08 +0100

llvm-toolchain-18 (1:18.1.0~rc1-2) unstable; urgency=medium

  [ Steve Langasek ]


=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: devel
 Priority: optional
 Rules-Requires-Root: no
-Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>, Gianfranco Costamagna <locutusofborg@debian.org>
 Build-Depends: debhelper (>= 10.0), cmake, ninja-build,
     chrpath, texinfo, sharutils,
@@ -16,22 +17,24 @@
     lcov, procps, help2man,
     zlib1g-dev, libzstd-dev,
     g++-multilib [amd64 i386 kfreebsd-amd64 mips64 mips64el mipsel powerpc ppc64 s390 s390x sparc sparc64 x32],
-    libjs-mathjax, python3-myst-parser | python3-recommonmark,
+    libjs-mathjax, python3-myst-parser | python3-recommonmark, python3-pexpect,
     doxygen,
     ocaml-base [amd64 arm64 armhf ppc64el riscv64 s390x] | ocaml-nox [amd64 arm64 armhf ppc64el riscv64 s390x],
     ocaml-findlib [amd64 arm64 armhf ppc64el riscv64 s390x],
     libctypes-ocaml-dev [amd64 arm64 armhf ppc64el riscv64 s390x],
     dh-exec, dh-ocaml [amd64 arm64 armhf ppc64el riscv64 s390x],
     libpfm4-dev [linux-any], python3-setuptools, libz3-dev,
-    llvm-spirv-17 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello,
-    spirv-tools [linux-any] | hello [!i386],
-    wasi-libc | hello,
+# "| hello" is for older buster/bionic distros without spirv support
+# We need to keep the constraints coherent between the two alternatives, otherwise
+# hello would get installed unexpectedly and prevent e.g. wasi-libc from getting pulled
+    llvm-spirv-17 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
+    spirv-tools [linux-any],
+    wasi-libc,
     libcurl4-openssl-dev | libcurl-dev,
     libgrpc++-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
     protobuf-compiler-grpc [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
     libprotobuf-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
     protobuf-compiler [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x]
-# "| hello" is for older buster/bionic distros without spirv support
 Build-Conflicts: oprofile
 Standards-Version: 4.6.2
 Homepage: https://www.llvm.org/
@@ -45,7 +48,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
  ${dep:devlibs-objc},
  libllvm19 (= ${binary:Version}),
- libclang-common-19-dev (= ${source:Version}),
+ libclang-common-19-dev (= ${binary:Version}),
  llvm-19-linker-tools (= ${binary:Version}),
  libclang1-19 (= ${binary:Version}), libc6-dev, binutils
 Provides: c-compiler, objc-compiler, c++-compiler
@@ -94,7 +97,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
  libllvm19 (= ${binary:Version}),
- libclang-common-19-dev (= ${source:Version}),
+ libclang-common-19-dev (= ${binary:Version}),
  clang-tools-19, python3-yaml
 Description: clang-based C++ linter tool
  Provide an extensible framework for diagnosing and fixing typical programming
@@ -106,7 +109,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
  libllvm19 (= ${binary:Version}),
- libclang-common-19-dev (= ${source:Version}),
+ libclang-common-19-dev (= ${binary:Version}),
 Description: Language server that provides IDE-like features to editors
  clangd understands your C++ code and adds smart features to your editor:
   - code completion
@@ -133,6 +136,7 @@
  This package contains the documentation.
 
 Package: libclang1-19
+Provides: ${t64:Provides}
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -158,7 +162,7 @@
 Section: libdevel
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
  ${dep:devlibs-objc}, libclang1-19 (= ${binary:Version}),
- libclang-common-19-dev (= ${source:Version})
+ libclang-common-19-dev (= ${binary:Version})
 Description: Clang library - Development package
  Clang project is a C, C++, Objective C and Objective C++ front-end
  based on the LLVM compiler. Its goal is to offer a replacement to the
@@ -171,8 +175,8 @@
  libclang1-19.
 
 Package: libclang-common-19-dev
-Architecture: all
-Multi-Arch: foreign
+Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: ${shlibs:Depends}, ${misc:Depends},
 Recommends: libclang-rt-19-dev
@@ -234,6 +238,7 @@
 # ------------- clang libraries -------------
 
 Package: libclang-cpp19
+Provides: ${t64:Provides}
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, libllvm19 (= ${binary:Version})
@@ -290,8 +295,3 @@
  .
  LibFuzzer is similar in concept to American Fuzzy Lop (AFL), but it performs
  all of its fuzzing inside a single process. This in-process fuzzing can be
- more restrictive and fragile, but is potentially much faster as there is no
- overhead for process start-up.
- .
- The fuzzer is linked with the library under test, and feeds fuzzed inputs to
- the library via a specific fuzzing entrypoint (aka 'target function'); the

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,6 @@
 # polly & lldb aren't enabled for every platform
 PROJECTS = clang;clang-tools-extra;lld;cross-project-tests;mlir
 # openmp & libunwind aren't enabled for every platform
-RUNTIMES = compiler-rt;libcxx;libcxxabi
 
 TARGET_BUILD	:= build-llvm
 TARGET_BUILD_STAGE2    := $(TARGET_BUILD)/tools/clang/stage2-bins
@@ -16,11 +15,34 @@
 LLVM_EPOCH := 1:
 LLVM_VERSION   := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:([0-9]+).*,\1,p")
 LLVM_VERSION_FULL := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\1,p")
+LLVM_VERSION_MINOR := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:[0-9]+\.([0-9]+)\.[0-9]+.*,\1,p")
 LLVM_VERSION_SNAPSHOT := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:(.*),\1,p")
 ifeq ($(LLVM_VERSION),$(LLVM_VERSION_FULL))
 	LLVM_VERSION_FULL := $(LLVM_VERSION).0.0
+	LLVM_VERSION_MINOR := 0
 endif
 LLVM_VERSION_NEXT := $(shell echo $(LLVM_VERSION_FULL) | awk -F. '{ OFS="."; $$NF+=1; print}')
+
+# dpkg-buildflags support
+# disable fixfilepath in favor of the llvm-project supplied flavor, disable lto
+# remove +time64,+lfs once the time64_t transition starts
+ifeq ($(DEB_HOST_ARCH),i386)
+  RUNTIMES = compiler-rt;libcxx;libcxxabi
+  export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
+else
+  ifeq ($(DEB_HOST_ARCH_BITS),32)
+    RUNTIMES = libcxx;libcxxabi
+    export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto abi=+time64,+lfs
+    skip_packages = -Nlibclang-rt-$(LLVM_VERSION)-dev
+  else
+    RUNTIMES = compiler-rt;libcxx;libcxxabi
+    ifeq ($(DEB_HOST_ARCH),mips64el)
+        export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto hardening=-stackprotector,-stackprotectorstrong
+    else
+        export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
+    endif
+  endif
+endif
 
 SOURCE_NAME := $(shell dpkg-parsechangelog -S Source)
 ifneq (,$(findstring snapshot,$(SOURCE_NAME)))
@@ -63,9 +85,6 @@
 
 CONFIGURE_EXTRA =
 
-# dpkg-buildflags support
-# disable fixfilepath in favor of the llvm-project supplied flavor, disable lto
-export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
 # these are handled on a per stage / build basis
 ifeq ($(VENDOR)-$(DEB_HOST_ARCH),Ubuntu-ppc64el)
   export DEB_CFLAGS_MAINT_STRIP = -g -O3
@@ -173,20 +192,3 @@
 
 ifneq (,$(findstring $(DEB_HOST_ARCH),armel))
   STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=arm-linux-gnueabi
-# align arch profile with debian baseline
-# https://wiki.debian.org/ArmEabiPort
-  CFLAGS_EXTRA += -march=armv5t
-  CXXFLAGS_EXTRA += -march=armv5t
-# disable compiler-rt builtins (not supported for baseline armel arch: armv5t)
-# See http://lists.llvm.org/pipermail/llvm-dev/2016-May/099761.html
-  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_BUILD_BUILTINS=OFF
-  COMPILER_RT_USE_BUILTINS_LIBRARY := OFF
-  LIBCXX_USE_COMPILER_RT := OFF
-# disable scudo standalone (not supported for baseline armel arch: armv5t)
-  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_BUILD_SCUDO_STANDALONE=OFF
-endif
-
-ifneq (,$(findstring $(DEB_HOST_ARCH),armhf))
-  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=arm-linux-gnueabihf
-# align arch profile with debian baseline
-# https://wiki.debian.org/ArmHardFloatPort#Minimum_CPU_.26_FPU

## llvm-toolchain-snapshot 19~++20240421021844+e095d978ba47

=== debian/changelog ===
llvm-toolchain-snapshot (1:19~++20240421021844+e095d978ba47-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * Make libclang-common-19-dev architecture dependent.
  * Add python3-pexpect in the build dep for lldb.
  * Fix sanitizer build on 32bit time_t64 architectures.
  * Refresh the 23-strlcpy_strlcat_warning_removed patch.
  * Build-depend on llvm-spirv-18 instead of llvm-spirv-17.
  * Add a stage1 profile to disable curl, grpc and spirv.

  [ Sylvestre Ledru ]
  * New snapshot release
  * Also install libMLIRExecutionEngineShared.so
  * Remove lang-to-external-fc to match upstream change in
    4841d70a4b7d7cd8c492c16a9da339ec75bca135

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 21 Apr 2024 14:21:37 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,7 @@
 Section: devel
 Priority: optional
 Rules-Requires-Root: no
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
+Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>, Gianfranco Costamagna <locutusofborg@debian.org>
 Build-Depends: debhelper (>= 10.0), cmake, ninja-build,
     chrpath, texinfo, sharutils,
@@ -27,14 +26,14 @@
 # "| hello" is for older buster/bionic distros without spirv support
 # We need to keep the constraints coherent between the two alternatives, otherwise
 # hello would get installed unexpectedly and prevent e.g. wasi-libc from getting pulled
-    llvm-spirv-17 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
-    spirv-tools [linux-any],
-    wasi-libc,
-    libcurl4-openssl-dev | libcurl-dev,
-    libgrpc++-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
-    protobuf-compiler-grpc [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
-    libprotobuf-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
-    protobuf-compiler [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x]
+    llvm-spirv-18 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
+    spirv-tools [linux-any] <!stage1> | hello [linux-any],
+    wasi-libc | hello,
+    libcurl4-openssl-dev <!stage1> | libcurl-dev <!stage1>,
+    libgrpc++-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
+    protobuf-compiler-grpc [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
+    libprotobuf-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
+    protobuf-compiler [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
 Build-Conflicts: oprofile
 Standards-Version: 4.6.2
 Homepage: https://www.llvm.org/
@@ -294,4 +293,3 @@
  of other libraries.
  .
  LibFuzzer is similar in concept to American Fuzzy Lop (AFL), but it performs
- all of its fuzzing inside a single process. This in-process fuzzing can be

=== debian/rules ===
--- 
+++ 
@@ -176,6 +176,7 @@
 # clangd remote index support requires GRPC & protobuf.
 # Enable if minimum tested versions are available.
 CLANGD_GRPC_INSTALLED=no
+ifeq (,$(filter stage1, $(DEB_BUILD_PROFILES)))
 ifeq ($(shell v=$$(dpkg-query -W -f '$${Version}' libgrpc++-dev 2>/dev/null); if [ -z "$$v" ]; then echo 1; else dpkg --compare-versions $$v gt 1.30.0; echo $$?; fi),0)
 ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' protobuf-compiler-grpc) gt 1.30.0; echo $$?),0)
 ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libprotobuf-dev) gt 3.12.0; echo $$?),0)
@@ -186,9 +187,9 @@
 endif
 endif
 endif
+endif
 
 export CC=gcc-$(GCC_VERSION)
 export CXX=g++-$(GCC_VERSION)
 
 ifneq (,$(findstring $(DEB_HOST_ARCH),armel))
-  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=arm-linux-gnueabi
